var Useless = Useless || {};

Useless.HttpRequestText = function(args) {
    var _args = {};
    _args.url = (args.url !== undefined ? args.url: null);
    _args.type = (args.type !== undefined ? args.type: null);
    _args.data = (args.data !== undefined ? args.data: null);
    var _readyState = 0;
    var _responseText = null;

    var _setResponse = function (xhr) {
        _responseText = xhr.responseText;
    }

    var _sendRequest = function (callback) {
        var xhr = new XMLHttpRequest();
        xhr.onreadystatechange = function(){
            if (xhr.readyState === 4) {
                _readyState = xhr.readyState;
                if (xhr.status === 200) {
                    _setResponse(xhr);
                }
                callback();
            }
        };
        if (_args.type !== null && _args.url !== null) {
            xhr.open(_args.type, _args.url);
            xhr.send(_args.data);
        }
    }

    Object.defineProperties(this, {
        url: {
            get: function () { return _args.url; }
        },
        type: {
            get: function () { return _args.type; }
        },
        data: {
            get: function () { return _args.data; }
        },
        readyState: {
            get: function () { return _readyState; }
        },
        responseText: {
            get: function () { return _responseText; }
        },
        setResponse: {
            set: function (value) { _setResponse = value }
        }
    });

    this.done = function (callback) {
        /* var count = 0;
        var judgeRetry = function() {
            if (_responseText !== null || count > 1) {
                callback();
            } else {
                setTimeout(function(){_sendRequest(judgeRetry)}, 500);
                // _sendRequest(judgeRetry);
                count++;
            };
        } */;
        // _sendRequest(judgeRetry);
        _sendRequest(callback);
    }
}


Useless.HttpRequestJSON = function(args) {
    Useless.HttpRequestText.call(this, args);
    var _responseJSON = null;

    this.setResponse = function (xhr) {
        _responseText = xhr.responseText;
        _responseJSON = JSON.parse(_responseText);
    }

    Object.defineProperties(this, {
        responseJSON: {
            get: function () { return _responseJSON; }
        }
    });
};
Useless.HttpRequestJSON.prototype = new Useless.HttpRequestText({});


Useless.HttpRequestXML = function(args) {
    Useless.HttpRequestText.call(this, args);
    var _responseXML = null;

    this.setResponse = function (xhr) {
        _responseText = xhr.responseText;
        _responseXML = xhr.responseXML;
    }

    Object.defineProperties(this, {
        responseXML: {
            get: function () { return _responseXML; }
        }
    });
};
Useless.HttpRequestXML.prototype = new Useless.HttpRequestText({});